<template>
  <div class="app-container">

   <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
     <el-form-item label="账单id" prop="doctorId" size="small">
       <el-input
         v-model="queryParams.billId"
         placeholder="请输入账单ID"
         clearable
         size="small"
         @keyup.enter.native="handleQuery"
       />
     </el-form-item>

     <el-form-item label="标题" prop="title" size="small">
       <el-input
         v-model="queryParams.title"
         placeholder="请输入标题"
         clearable
         size="small"
         @keyup.enter.native="handleQuery"
       />
     </el-form-item>
     <el-form-item label="类型" prop="billType">
       <el-select v-model="queryParams.billType" placeholder="请选择类型" clearable size="small">
         <el-option
           v-for="dict in billTypeOptions"
           :key="dict.dictValue"
           :label="dict.dictLabel"
           :value="dict.dictValue"
         />
       </el-select>
     </el-form-item>
     <el-form-item label="提现时间" prop="createTime" size="small">
       <el-date-picker clearable size="small"
         v-model="queryParams.createTime"
         type="date"
         value-format="yyyy-MM-dd"
         placeholder="选择提现时间">
       </el-date-picker>
     </el-form-item>

     <el-form-item>
       <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
       <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
     </el-form-item>
   </el-form>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
    <el-table v-loading="loading" :data="storebillList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="账单ID" align="center" prop="billId" />
      <el-table-column label="店铺名称" align="center" prop="name" width="150px"/>
      <el-table-column label="标题" align="center" prop="title" />
      <el-table-column label="金额" align="center" prop="money" />
      <el-table-column label="余额" align="center" prop="balance" />
      <el-table-column label="类型" align="center" prop="billType">
        <template slot-scope="scope">
          <dict-tag :options="billTypeOptions" :value="scope.row.billType"/>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="180" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right">
 <template slot-scope="scope">
        <el-button
            size="mini"
            type="text"
            @click="handledetails(scope.row)"
          >详情
        </el-button>
      </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
 <el-drawer
        size="75%"
        :title="show.title" :visible.sync="show.open">
     <storeBillDetails  ref="Details" />
 </el-drawer>
</div>
</template>

<script>
import { listStorebill, getStorebill, delStorebill, addStorebill, updateStorebill, exportStorebill } from "@/api/store/storeBill";
import storeBillDetails from '../../components/store/storeBillDetails.vue';
export default {
  name: "Storebill",
    components: { storeBillDetails },
  data() {
    return {
      show:{
              title:"账单详情",
              open:false,
            },
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 店铺帐单记录表格数据
      storebillList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        storeId: null,
        title: null,
        money: null,
        balance: null,
        billType: null,
        businessId: null
      },
      // 类型字典
      billTypeOptions: [],
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
    this.getDicts("sys_bill_type").then(response => {
      this.billTypeOptions = response.data;
    });
  },
  methods: {
    handledetails(row){
            this.show.open=true;
            setTimeout(() => {
                  this.$refs.Details.getDetails(row.billId,row.name);
            }, 1);
        },
    /** 查询店铺帐单记录列表 */
    getList() {
      this.loading = true;
      listStorebill(this.queryParams).then(response => {
        this.storebillList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        billId: null,
        storeId: null,
        title: null,
        money: null,
        balance: null,
        billType: null,
        remark: null,
        createTime: null,
        businessId: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.billId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加店铺帐单记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const billId = row.billId || this.ids
      getStorebill(billId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改店铺帐单记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.billId != null) {
            updateStorebill(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addStorebill(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const billIds = row.billId || this.ids;
      this.$confirm('是否确认删除店铺帐单记录编号为"' + billIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delStorebill(billIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有店铺帐单记录数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportStorebill(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
